  ORG 28001

** SOUNDBOX (C) P.D'ARCY 1984
 LBRA START
* SOUND SEL. PARAM. FROM BASIC *
BPARAM FCB 5
* EQUATES
EDAC EQU $FF20  ;ADDR OF DAC
EENAB EQU $FF23 ;SBD ENAB.
EENON EQU $08   ;SOUND ON
EENOF EQU $F7   ; OFF
ESSEL EQU $BD41 ;SOUND SELECT
ESDAC EQU $00   ;SELECT DAC
EROAR EQU $8000 ;START 'ROAR'
EROARE EQU $C000 ;END OF 'ROAR'

*********************
** CONTROL ROUTINE **
*********************
START PSHS D,X,Y,U
 BSR SNDON
 LEAX SNDTAB,PCR
 LDA BPARAM,PCR
 ASLA
 LDD A,X
 JSR D,X
 BSR SNDOFF
 PULS D,X,Y,U,PC

** SOUND ROUTINE TABLE
SNDTAB
 FDB LASER-SNDTAB ; 0-BPARAM
 FDB PHASER-SNDTAB ;1
 FDB ROAR-SNDTAB   ;2
 FDB EXPLOD-SNDTAB ;3
 FDB GUN-SNDTAB    ;4
 FDB FREQ-SNDTAB   ;5

*****************
** SUBROUTINES **
*****************

 *** TURN DAC  SOUND SOURCE ON **
SNDON PSHS D,U
 LDB #ESDAC
 JSR $BD41 *ESSEL
 LDB $FF23 *EENAB
 ORB #EENON
 STB $FF23 *EENAB
 PULS PC,U,D * PULS D,U,PC

*** TURN DAC SOUND SOURCE OFF **
SNDOFF PSHS A
 LDA $FF23 *EENAB
 ANDA #$F7 *EENOF
 STA $FF23 *EENAB
 PULS PC,A *PULS A,PC

*** MAKE SOUND IN REG.A **
SOUND PSHS A
 ASLA
 ASLA
 PSHS A
 LDA $FF20 *EDAC
 ANDA #$03
 ORA ,S *ORA 0,S
 STA $FF20 *EDAC
 LEAS 1,S
 PULS PC,A *PULS A,PC

*** PITCH (DELAY=REG.B) **
PITCH PSHS B
PITCHD DECB
 BNE PITCHD
 PULS PC,B *PULS B,PC

** MAKE SOUND(A) WITH PITCH(B) **
NOISE BSR SOUND
 BSR PITCH
 RTS

*************
*** LASER ***
*************
LASER LDB #1
LASERL LDA #63
 BSR NOISE
 CLRA
 BSR NOISE
 INCB
 CMPB #200
 BNE LASERL
 RTS

**************
*** PHASER ***
**************
VLEVEL FCB 0
PHASER LDY #5
PHASEB LDA #63
 STA VLEVEL,PCR
PHASEC BSR SOUND
 DECA
 BNE PHASEC
 DEC VLEVEL,PCR
 LDA VLEVEL,PCR
 BNE PHASEC
 LEAY -1,Y
 BNE PHASEB
 RTS

********************
** THE BASIC ROAR **
********************
ROAR LDX #$8000 *EROAR
 LDB #20
ROARD LDA ,X+
 BSR NOISE
 CMPX #$C000 *EROARE
 BNE ROARD
 RTS

*** FADE THE NOISE IN REG.A ***
VMASK FCB 0
FADE PSHS A
 ANDA VMASK,PCR
 BSR NOISE
 PULS PC,A *PULS A,PC

*************************
**EXPLOSION WITH FADE ***
*************************
EXPLOD LDA #63
 STA VMASK,PCR
 LDX #$8000 *EROAR
EXPLOG LDB #20
 LDA ,X+ * LDA 0,X+
 BSR FADE
 TFR X,D
 ANDB #$FF
 BNE EXPLOK
 DEC VMASK,PCR
EXPLOK CMPX #$C000 *EROARE
 BCS EXPLOG *BLO EXPLOG
 RTS

***********************
** FUNSHOT WITH FADE **
***********************
GUN LDX #$8000 *EROAR
 LDA #63
 STA VMASK,PCR
 LDB #20
 LDA #63
 BSR NOISE
 CLRA
 BSR NOISE
GUNSHT LDB #20
 LDA ,X+ * LDA 0,X+
 BSR FADE
 TFR X,D
 ANDB #$03
 BNE GUNSHT
 DEC VMASK,PCR
 BNE GUNSHT
 RTS

**************************
*** FREQUONICS (ALARM) ***
**************************
VFREQV FCB 0
VFREQ1 FCB 0
VFREQ2 FCB 0
VFREQ3 FCB 0

FREQ LDY #400
 LDA #255
 STA VFREQV,PCR
 LDA #1
 STA VFREQ1,PCR
 STA VFREQ2,PCR
 STA VFREQ3,PCR
FREQA DEC VFREQ1,PCR
 BNE FREQB
 BSR FREQS1
 LDA #120
 STA VFREQ1,PCR
 LEAY -1,Y
 BNE FREQB
 RTS
FREQB DEC VFREQ2,PCR
 BNE FREQC
 BSR FREQS2
 LDA #60
 STA VFREQ2,PCR
FREQC DEC VFREQ3,PCR
 BNE FREQA
 BSR FREQS3
 LDA #30
 STA VFREQ3,PCR
 BRA FREQA
FREQS1 LDA #63
 BRA FREQSS
FREQS2 LDA #10
 BRA FREQSS
FREQS3 DEC VFREQV,PCR
 LDA VFREQV,PCR
FREQSS LBSR SOUND
 CLRA
 LBSR SOUND
 RTS
 FCB 0,0
